#
# Sensus Consulting Ltd (C) 1997
#
# Matt Newman - matt@sensus.org
#
# Implements Win95-style Process Bar
#
#INDEX\
proc tk++::Progress {} {}

package require tk++

proc progress {w args} {
	return [uplevel 1 ::tk++::Progress $w $args]
}
class tk++::Progress {
	inherit itk::Widget

	constructor {args} {}

	public method setind {pc} {configure -pc $pc}

	itk_option define -nsteps nSteps NSteps 20
	itk_option define -pc perCent perCent 0.0 {_reconfig}
	itk_option define -font	font Font {{MS Sans Serif} 8}
	itk_option define -width width Width 200
	itk_option define -height height Height 20
	itk_option define -fill fill Fill #004080

	protected method _reconfig {}
	private variable _initialized 0
}
body tk++::Progress::constructor {args} {
	itk_component add canvas {
		canvas $itk_interior.c -background darkgrey -height 20 -width 200
	} {
		keep -width -height -background -relief
		keep -highlightthickness
	}
	pack $itk_component(canvas) -fill both -expand yes

	eval itk_initialize $args

	set inc [expr $itk_option(-width)/double($itk_option(-nsteps))]
	for {set i 0} {$i <= $itk_option(-nsteps)} {incr i} {
		set v($i)	[$itk_component(canvas) create rect \
					[expr $i*$inc+1] 0 \
					[expr ($i+1)*$inc-1] $itk_option(-height) \
					-fill {} -outline {}]
	}
	# Need to reposition after reconfig.
	set v(text) [$itk_component(canvas) create text \
				[expr $itk_option(-width)/2.0] [expr $itk_option(-height)/2.0] \
				-anchor c -fill white]
	set _(_initialized) 1
}
body tk++::Progress::_reconfig {} {
	if {$_(_initialized) == 0} {return}

	if {$itk_option(-pc) < 0.0} {set itk_option(-pc) 0.0}
	if {$itk_option(-pc) > 1.0} {set itk_option(-pc) 1.0}

	set pc [expr int($itk_option(-pc)*$itk_option(-nsteps))]
	for {set i 0} {$i <= $pc} {incr i} {
		$itk_component(canvas) itemconf $v($i) -fill $itk_option(-fill) -outline black
	}
	for {} {$i < $itk_option(-nsteps)} {incr i} {
		$itk_component(canvas) itemconf $v($i) -fill {} -outline {}
	}
	$itk_component(canvas) itemconf $v(text) -text "[expr int($itk_option(-pc)*100)]%"

	update idletasks
}
